# $Id: hier_test.rb 40384 2012-05-08 07:33:11Z skelem $

# First we pull in the standard API hooks.
require 'sketchup.rb'

# Show the Ruby Console at startup so we can
# see any programming errors we may make.
Sketchup.send_action "showRubyPanel:"

# Don't create a second menu entry.
unless file_loaded?('hier_test.rb')
  plugins = Sketchup.find_support_file("Plugins")
  PROJECT_NAME = "hier_test"	# The name of the subdirectory under Sketchup/Plugins
  project_dir = Sketchup.find_support_file(PROJECT_NAME, "Plugins/")
#    project_dir = System.IO.Directory.CreateDirectory(plugins + "/" + PROJECT_NAME)
#  end
  require_all(project_dir)
  # Add a menu item to launch our plugin.
  UI.menu("PlugIns").add_item("Hierarchy Test") {
    #  Sketchup.active_model.start_operation "Hierarchy Test"
    # Call our new method.
    draw_hierarchy
    #  Sketchup.active_model.commit_operation
  }
  file_loaded('hier_test.rb')
end

IDENTITY = Geom::Transformation.translation [0,0,0]
ZERO = Geom::Point3d.new(0,0,0)
Z_AXIS = Geom::Vector3d.new(0,0,1)

def draw_hierarchy
  ent = Sketchup.active_model.entities
  arrow_group = ent.add_group
  arrow_ents = arrow_group.entities

  # Draw an arrow pointing east.
  arrow = arrow_ents.add_face [-1,1,0], [1,1,0], [1,2,0], [3,0,0], [1,-2,0], [1,-1,0], [-1,-1,0]
  arrow.reverse!
  arrow.pushpull 1
  
  # Rotate arrow's group so the arrow points north.
  arrow_ents.transform_entities Geom::Transformation.rotation(ZERO, Z_AXIS, 90.degrees), arrow_group
  # move the arrow north by 5 to get it out of the way for the next arrow.
  arrow_ents.transform_entities(Geom::Transformation.translation([0,5,0]), arrow_group)

  # Draw another arrow (almost the same as the first, but with a longer tail so we can tell them apart) inside the same group as the first, but pointing to the east.
  arrow_e = arrow_ents.add_face [-2,1,-1], [1,1,-1], [1,2,-1], [3,0,-1], [1,-2,-1], [1,-1,-1], [-2,-1,-1]
  arrow_e.pushpull 1

end
